;ͻ
;   ENfo.Lsp                                           Jan 25, 1996   
;   Full Scale Entity Editing                                         
;ͼ
;============ Initiate Program =========================================
(princ "\nFabricated Designs, Inc.\nLoading Enfo v7.1 ")
 (setq Enfo nil Info nil)                     ;Reset Program Names
;%%%%%%%%%%%% Macros %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(defun PDot ()(princ "."))                    ;Print Dot
(defun BkSp () (write-char '8))               ;Back Space
(defun Beep (/ f)                             ;DOS Only
 (if (not (getenv "windir"))                  ;Beep
     (progn (setq f (open "con" "w"))         ;Open CON To Write
            (write-char '7 f)                 ;Print Hex 7
            (close f))))                      ;Close CON
(defun GetVal (n e) (cdr (assoc n e)))        ;Get Value
(defun AtoR (a) (* pi (/ a 180.0)))           ;Angle To Radian
(defun RtoA (r) (/ (* r 180.0) pi))           ;Radian To Angle
(defun en_err (e) (beep)                      ;Error Routine
              (princ (strcat "\nError: " e)))

(PDot);=========== Setup Lists =========================================
(setq VList (list 2 3 40 41 42 70 71 72 73 74);Setup Variable List
      CList (list (cons 0 "<ByBlock>") (cons 1 "_Red")  (cons 2 "_Yellow")
(cons 3 "_Green")  (cons 4 "_Cyan")      (cons 5 "_Blue") (cons 6 "_Magenta")
(cons 7 "_White")  (cons 8 "...255 Varies") (cons 256 "<ByLayer>"))
      GList (list                             ;Setup Group Code List
(cons "ALL-2"  "<RO> Main Entity")   (cons "ALL-1"  "<RO> Entity Name")
(cons "ALL0"   "<RO> Entity Type")   (cons "ALL1"   "Text")
(cons "ALL5"   "<RO> Handle")        (cons "ALL6"   "LineType")
(cons "ALL7"   "Text Style")         (cons "ALL8"   "Layer")
(cons "ALL10"  "First Point")        (cons "ALL11"  "Second Point")
(cons "ALL12"  "Third Point")        (cons "ALL13"  "Forth Point")
(cons "ALL14"  "Ref Point")          (cons "ALL15"  "Ref Point")
(cons "ALL16"  "Ref Point")          (cons "ALL38"  "Elevation")
(cons "ALL39"  "Thickness")          (cons "ALL41"  "X Scale Factor")
(cons "ALL42"  "Y Scale Factor")     (cons "ALL43"  "Z Scale Factor")
(cons "ALL44"  "Row Spacing")        (cons "ALL45"  "Column Spacing")
(cons "ALL50"  "First Angle")        (cons "ALL51"  "Oblique Angle")
(cons "ALL52"  "Ext Line Angle")     (cons "ALL53"  "Text Angle")
(cons "ALL62"  "Color")              (cons "ALL66"  "<RO> Seq Flag")
(cons "ALL67"  "Paper Space")        (cons "ALL68"  "<RO> Status")
(cons "ALL69"  "<RO> ID")            (cons "ALL75"  "Surface Type")
(cons "ALL100" "<RO> SubClass")      (cons "ALL210" "UCS Extrusion")
(cons "ALL48"  "LineType Scale")     (cons "ATT2"   "Attrib Tag")
(cons "INS2"   "<RO> Block Name")    (cons "SHA2"   "<RO> Shape Name")
(cons "DIM2"   "<RO> Dim Name")      (cons "ATT3"   "Prompt")
(cons "DIM3"   "<RO> Dim Style")     (cons "ARC40"  "Radius")
(cons "ATT40"  "Text Height")        (cons "CIR40"  "Radius")
(cons "POL40"  "Starting Width")     (cons "SHA40"  "XY Scale Factor")
(cons "TEX40"  "Text Height")        (cons "MTE40"  "<RO> Text Height")
(cons "VER40"  "Starting Width")     (cons "MTE41"  "<RO> Width")
(cons "DIM40"  "Leader Length")      (cons "VIE40"  "<RO> Width")
(cons "ELL40"  "Minor Axis")         (cons "ELL41"  "Starting")
(cons "VIE41"  "<RO> Height")        (cons "ATT41"  "Relative Scale")
(cons "INS41"  "X Scale Factor")     (cons "POL41"  "Ending Width")
(cons "SHA41"  "Relative X")         (cons "TEX41"  "X Scale Factor")
(cons "VER41"  "Ending Width")       (cons "MLI41"  "Scale Factor")
(cons "ELL42"  "Ending")             (cons "INS42"  "Y Scale Factor")
(cons "VER42"  "Bulge Factor")       (cons "ATT70"  "Flag")
(cons "INS70"  "Row Count")          (cons "POL70"  "Flag")
(cons "VER70"  "Flag")               (cons "3DF70"  "Invisible Edges")
(cons "3DS70"  "<RO> Flag")          (cons "DIM70"  "Dimension Type")
(cons "ATT71"  "Flag")               (cons "INS71"  "Column Count")
(cons "TEX71"  "Flag")               (cons "ATT72"  "Flag")
(cons "MTE71"  "<RO> Flag")          (cons "MTE72"  "<RO> Flag")
(cons "TEX72"  "Justify Flag")       (cons "ATT73"  "Field Length")
(cons "TEX73"  "Justify Flag")       (cons "MLI73"  "Number Of Vertices")
(cons "ATT74"  "Not Listed")         (cons "VER71"  "Face 1")
(cons "VER72"  "Face 2")             (cons "VER73"  "Face 3")
(cons "VER74"  "Face 4")             (cons "POL71"  "Face 1")
(cons "POL72"  "Face 2")             (cons "POL73"  "Face 3")
(cons "POL74"  "Face 4")))

;%%%%%%%%%%%% Sub Routines %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(PDot);+++++++++ Set Modes & Error +++++++++++++++++++++++++++++++++++++
 (defun en_smd ()                             ;Define Enfo Set Mode
  (command "_.UNDO" "_CONTROL" "_ALL")            ;Set An Undo Control
  (command "_.UNDO" "_GROUP")                    ;Start An Undo Group
  (setq m_v nil m_n nil                       ;Reset Name & Value
        m_l (list "CMDECHO" "BLIPMODE" "HIGHLIGHT" "SNAPMODE")
        m_s (list 0 0 1 0)                    ;Set Up Mode List
     olderr *error*                           ;Set Old Error
    *error* (lambda (e)                       ;Set Error So That
     (if (or (= e "Function cancelled")       ;If Cancel Or
             (= e "quit / exit abort"))       ;Abort Appears
         (setq en_4 nil)                      ;Then Set Text Screen
         (princ (strcat "\nError: " e)))      ;Else Print Error
     (command "_.UNDO" "_END")                   ;Undo All Changes
     (command "_.UNDO" 1)                       ;Group Started
    (en_rmd)))                                ;Then Return Modes
  (if (not (entnext)) (progn                  ;Check For Empty Drawing
      (en_err "There Are No Entities To Edit!")(quit)))
  (foreach x m_l (setq m_v (cons (getvar x) m_v);Get Value
                       m_n (cons x m_n)))     ;And Variable
  (mapcar 'setvar m_l m_s)                    ;Set New Modes
  (princ "\nEntity Editing ..."))             ;Display Program

(PDot);++++++++++++ Return Modes & Error +++++++++++++++++++++++++++++++
 (defun en_rmd ()                             ;Define Enfo Return Mode
  (command "_.UNDO" "_END")                      ;End Undo Group
  (setq *error* olderr)                       ;Reset Error
  (if en_4 (textscr)                          ;End At Text Screen
           (if s (redraw)))                   ;Redraw Bug In SVADIv1.0
  (mapcar 'setvar m_n m_v)                    ;Reset Modes
  (prin1))                                    ;Exit Clean

(PDot);++++++++++++ First Change Routine +++++++++++++++++++++++++++++++
 (defun en_ch1 ()                             ;Define First Change
  (if en_4                                    ;If Seqend
   (prompt "\nEnd Of Sequence\n")             ;End Program
    (progn (initget "Yes No")                 ;Else Ask To Change
     (if (= "Yes" (getkword "\nDo You Wish To Change A Value <N>:... "))
         (en_emod)))))                        ;If Yes Run en_emod

(PDot);+++++++++++ Second Change Routine +++++++++++++++++++++++++++++++
 (defun en_ch2 ()                             ;Define Second Change
  (graphscr)                                  ;Goto Graphscr
  (initget "Yes No")                          ;Ask To Change Another
  (if (= "Yes"  (getkword "\nChange Another Value <N>:... "))
      (progn (textscr)                        ;If Yes
             (terpri)                         ;Run
             (en_ent)                         ;Editing
             (en_emod))                       ;Routine Again
      (progn (redraw ms 4)                    ;Else
             (setq en_5 nil))))               ;End Change

(PDot);++++++++++++ Check For Group Code Idiosyncrasies ++++++++++++++++
(defun en_cod ()                              ;Define Check Code
 (setq RList (cons 100 RList))                ;Set 100 Read Only
 (and (= etype "VIEWPORT")                    ;For Viewports
      (foreach x (list 40 41 67)              ;Set Width, Height, And
      (setq RList (cons x RList))))           ;Paper Space To Read Only
 (if (or (and (not en_8)(= grpc 6))           ;If Linetype
         (and (not en_9)(= grpc 38))          ;Elevation
         (and (not en_2)(= grpc 39))          ;Thickness
         (and (not en_3)(= grpc 62)))         ;Or Color Allowed
         (setq EList (cons grpc EList)))      ;Add Code To EList
 (if (not (member grpc EList))                ;If Code Not A Member
     (en_err                                  ;Of EList Error Out
       (strcat "Group Code " (itoa grpc) " Does Not Exist")))
 (and (= grpc 2)                              ;For Group 2 That Are Not
      (/= etype "ATTDEF")                     ;Attribute Definitions
      (setq RList (cons 2 RList)))            ;Set For Read Only
 (and (= grpc 70)                             ;For Group 70 That Are
      (= etype "3DSOLID")                     ;3DSolids
      (setq RList (cons 70 RList)))           ;Set For Read Only
 (and (= grpc 3)                              ;For Group 3 That Are
      (= etype "DIMENSION")                   ;Dimensions
      (setq RList (cons 3 RList)))            ;Set For Read Only
 (and (member grpc RList)                     ;For Read Only Types
      (member grpc EList)                     ;That Actually Exist
      (en_err "READ ONLY - ACCESS DENIED !!"));Error Out
 (and (member grpc EList)                     ;If Type Does Exist &
      (not (member grpc RList))               ;Not Read Only
      (setq en_6 T))                          ;Set Test 6 True
 (if (= grpc 6)(en_ptb "LTYPE"))              ;Print LType Table
 (if (= grpc 7)(en_ptb "STYLE"))              ;Print Style Table
 (if (= grpc 8)(en_ptb "LAYER"))              ;Print Layer Table
 (if (and (>= grpc 10)                        ;For Points
          (<= grpc 19)                        ;That Exist
          (member grpc EList))                ;Check UCS
     (progn (if (and                          ;For Types That Are
                (/= etype "3DFACE")           ;Not 3DFaces
                (/= etype "VIEWPORT"))        ;Or Viewports
                (en_ucs)(en_ckz))             ;Else Check Z Dim
            (graphscr)                        ;Use Pointer Or Keyboard
            (redraw s 3)))                    ;Highlight Entity
 (and (= grpc 62)                             ;For Colors
      (not en_3)                              ;Print
      (en_pc)))                               ;Table

(PDot);+++++++++++ Check UCS And Elevation +++++++++++++++++++++++++++++
 (defun en_ucs ()                             ;Define Check UCS
  (setq edir (GetVal 210 edef))               ;Get Ucs Extrusion
  (if edir                                    ;If Ucs Exists
   (if (= (getvar "WORLDUCS") 1)              ;If World UCS
       (setq ex (trans edir 1 0 1))           ;Translate To World
       (setq ex (trans edir 0 1 0))))         ;Else Translate To User
  (if edir                                    ;If Ucs Exists
   (if (not (equal ex (list 0 0 1) 0.000001)) ;If Not 0 0 1
       (en_err "WARNING!! Not Current UCS")   ;Of UCS
       (if (not en_4)(en_ckz)))))             ;Else Check Z

(PDot);++++++++++++ Check Z Value ++++++++++++++++++++++++++++++++++++++
 (defun en_ckz ()                             ;Define en_ckz
  (setq celv (getvar "ELEVATION")             ;Get Current Elevation
        ielv (caddr (GetVal grpc edef)))      ;Get Entity Elevation
  (if (and (/= etype "SOLID")                 ;If Not A Solid
           (/= celv ielv))                    ;And Z Not Equal
      (progn                                  ;Warn User
        (beep)                                ;Beep Current Elevation
        (princ "WARNING! Current Elevation: ");Print Current
        (princ (rtos celv 2 2))               ;Elevation
        (princ "  -  Point Z Value: ")        ;Print Entity
        (princ (rtos ielv 2 2))               ;Elevation
        (initget "Yes No")                    ;Ask To Change
        (if (= "Yes"                          ;To Entity Elevation
            (getkword "\nDo You Wish To Change To This Elevation <N>:   "))
            (command "_.ELEV" ielv (getvar "THICKNESS"))))));UCS Thickness

(PDot);++++++++++++ Print Value ++++++++++++++++++++++++++++++++++++++++
 (defun en_pv ()                              ;Define Print Values
  (setq edef (entget s)                       ;Get Entity Definition
         val (GetVal grpc edef))              ;Get Value
  (if  (member grpc VList)                    ;If Constant Name All
       (setq pcde (strcat (substr etype 1 3) (itoa grpc)))
       (setq pcde (strcat "ALL" (itoa grpc))));Else Name 3 Letter Code
  (setq des (GetVal pcde GList))              ;Set Description Value
  (if (not des)(setq des "Value"))            ;If Not Found
  (prompt (strcat "\nOld " des ":... "))      ;Print Value Prompt
  (and (>= grpc 50)(<= grpc 54)               ;If Angle
       (setq val (rtos (RtoA val) 2           ;Print In Degrees
            (if (> (getvar "AUPREC")) 4))))   ;With Min 4 Decimals
  (and (not val) (= grpc 39)                  ;If Thickness
       (setq val " 0.00"))                    ;Zero Print 0
  (if  (= grpc 38)                            ;For Elev Print Group 10 Z
       (setq val (rtos (caddr (GetVal 10 edef)))))
  (if val (princ val)                         ;Else Print As Listed
          (princ "ByLayer")))                 ;If Val Nil ByLayer

(PDot);++++++++++++ Print Tables And Make Valid Listing ++++++++++++++++
 (defun en_ptb (tname / ct prt)              ;Define Augments & Locals
  (setq ct 1 spc " ")                         ;Set Counter & Space
   (if (= tname "LTYPE")                      ;If LineType
    (progn (setq PList (cons "BYLAYER" PList));Add ByLayer
     (prompt (strcat "\nExisting: ByLayer - " ;Prompt With ByLayer
      (GetVal 6 (tblsearch "LAYER" (GetVal 8 edef))) "\n")))
       (prompt "\nExisting:\n"))              ;Else Just Prompt
(princ " ")                                   ;Align First Item
 (setq prt (cdr (cadr (tblnext tname T))))    ;Get First item
  (while prt                                  ;While Item Exists
   (if (> (strlen prt) 14)                    ;Limit Item
    (setq prt (strcat (substr prt 1 13) "")));To 14 Characters
     (princ prt)                              ;Print Item
      (repeat (- 15 (strlen prt)) (princ spc));And Spaces
    (if (zerop (rem ct 5)) (print))           ;Issue Return After 5
     (setq PList (cons prt PList)             ;Add To Item To List
              ct (1+ ct)                      ;Increase Counter
             prt (GetVal 2 (tblnext tname)))) ;Get Next Item
        (print))                              ;Issue A Return

(PDot);++++++++++++ Match Input Type To Getxxx +++++++++++++++++++++++++
(defun en_getx ()                             ;Define en_getxxx
 (prompt (strcat "\nNew " des ":... "))       ;Print Get Prompt
 (initget 1)                                  ;Disallow Null
 (if  (= grpc 1)(setq n (getstring T)))       ;For Strings & Dimensions
 (if  (= grpc 2)(setq n (getstring)))         ;For Attribute Tags
 (if  (= grpc 3)(setq n (getstring T)))       ;For Attribute Prompts
 (and (>= grpc 6)                             ;For LineTypes
      (<= grpc 8)                             ;Styles
      (setq n (getstring))                    ;And Layers
      (wcmatch n "*|*")                       ;Error
      (princ "Reference Dependent")           ;Out
      (setq n ""))                            ;For XRefs
 (and (>= grpc 10)                            ;For All
      (<= grpc 19)                            ;Points
      (setvar "SNAPMODE" 1)                   ;Turn Snap On
      (setq n (getpoint))                     ;Get New Point
      (if (= etype "SOLID")                   ;For Solids
      (prompt (strcat (rtos (car n))          ;Ignore Z
               ","    (rtos (cadr n))))       ;Dimensions
      (princ n)))                             ;Print Point
 (and (>= grpc 38)                            ;For
      (<= grpc 49)                            ;Real
      (setq n (getreal)))                     ;Numbers
 (and (>= grpc 50)                            ;For Angles
      (<= grpc 54)                            ;Get New Value
      (setq n (AtoR (getreal))))              ;In Degrees
 (if  (= grpc 62)                             ;For Colors
      (progn (setq n (strcase (getstring)))   ;Input As String
             (if (and (>= (atoi n) 1)         ;Convert
                      (<= (atoi n) 255))      ;1 Thru 255
                 (setq n (atoi n))            ;To Integer
                 (progn                       ;Else
      (cond ((= n "0")   (setq n "BYBLOCK"))  ;Allow 0
            ((= n "256") (setq n "BYLAYER"))) ;And 256
      (cond ((= n "BYBLOCK"))                 ;And ByLayer
            ((= n "_BYLAYER"))                 ;And ByBlock
            ((setq n "")))))))                ;Else Error Out
 (and (>= grpc 63)                            ;For Counts
      (<= grpc 80)                            ;& Flags
      (setq n (getint)))                      ;Get Integer
 (if  (= grpc 210)(setq n (getpoint))))       ;For UCS 3D Point

(PDot);++++++++++++ Check For Null Response ++++++++++++++++++++++++++++
 (defun en_cval ()                            ;Define en_cval
  (if (= n "")                                ;If Null
      (progn                                  ;Response
       (en_err "Invalid Response")            ;Error
       (setq en_7 nil))                       ;Out
      (setq en_7 T)))                         ;Else Initiate Change

(PDot);++++++++++++ Check For Elevation ++++++++++++++++++++++++++++++++
 (defun en_elv ()                             ;Define en_elv
  (if (= grpc 38)                             ;If Elevation Requested
   (progn (setq gp 10)                        ;Use Group 10
   (foreach x (list "TEXT" "ATTDEF" "ATTRIB") ;Unless Text Based
              (if (= etype x)(setq gp 11)))   ;Then Use Group 11
    (setq xpt (car (GetVal gp edef))          ;Old X Point
          ypt (cadr (GetVal gp edef))         ;Old Y Point
         nlev (list xpt ypt n)                ;Add New Z Point
          old (assoc gp edef)                 ;Get Old Point
          new (cons gp nlev)                  ;Set New Point
         edef (subst new old edef))           ;Make New Definition
      (entmod edef)                           ;Modify Definition
      (entupd s)                              ;Update Entity
      (setq en_7 nil))))                      ;ByPass en_emod

(PDot);++++++++++++ Get Group Code And Modify Entity +++++++++++++++++++
(defun en_emod ()                             ;Define en_emod
 (setq en_5 T                                 ;Set Second Change True
     RList '(-2 -1 0 5 66 68 69)              ;Reset Read Only List
     PList nil                                ;Reset Table List
       en_6 nil                               ;Reset Group Code
       pmt "\nOthers ")                       ;Reset Prompt
      (and (not en_8)                         ;If Linetype
           (not (member 6 EList))             ;Available But Not
 (setq pmt (strcat pmt " Linetype - 6 ")))   ;Present Prompt 6
      (and (not en_9)                         ;If Elevation
           (not (member 38 EList))            ;Available But Not
 (setq pmt (strcat pmt " Elevation - 38 "))) ;Present Prompt 38
      (and (not en_2)                         ;If Thickness
           (not (member 39 EList))            ;Available But Not
 (setq pmt (strcat pmt " Thickness - 39 "))) ;Present Prompt 39
      (and (not en_3)                         ;If Color
           (not (member 62 EList))            ;Available But Not
 (setq pmt (strcat pmt " Color - 62")))      ;Present Prompt 62
(if (/= pmt "\nOthers ")                      ;If Others Exist
 (prompt (strcat pmt "\n")))                  ;Display Choices
  (initget 1)                                 ;Disallow Null
   (setq grpc (getint "\nEnter Group Code:... "))
    (en_cod)                                  ;Check Code Number
     (if en_6                                 ;If Good Group Code
      (progn (en_pv)                          ;Print Current Value
       (en_getx)                              ;Get New Value
        (en_cval)                             ;Check For Null Response
         (en_elv)                             ;Check For Elevation
          (if en_7                            ;Initiate Change
;^^^^^^^^^^^^ Modify The Entity ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
    (progn                                    ;Check For
     (if PList                                ;Table List
      (if (not (member (strcase n) PList))    ;If New Value Is Not Member
       (en_err (strcat "\n" (strcase n) " Does Not Exist"))
       (setq PList nil)))                     ;Else Reset The List
     (if (not PList)                          ;If List Reset Or Empty
      (progn                                  ;Then Modify The Entity
        (prompt "\nChanging Entity...")       ;Display Status Of Edit
        (and (= grpc 10)(= en_10 T)           ;To Move A Viewport
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.MOVE" s "" (GetVal 10 Edef) n))
        (and (= grpc 8)(= en_10 T)            ;To Change Layers
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.CHPROP" s "" "_LA" n ""))   ;For Viewports
        (and (= grpc 39)(= en_2 nil)          ;For Color, Thickness
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.CHPROP" s "" "_T" n ""))    ;Or Linetype
        (and (= grpc 62)(= en_3 nil)          ;Use
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.CHPROP" s "" "_C" n ""))    ;CHPROP
        (and (= grpc 62)(= n "_BYBLOCK")       ;Use
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.CHPROP" s "" "_C" n ""))    ;CHPROP
        (and (= grpc 6)(= en_8 nil)           ;To Create This Group
         (setq en_11 T)                       ;Bypass Entmod
         (command "_.CHPROP" s "" "_LT" n ""))   ;If It Does Not Exist
      (if (not en_11)                         ;If Entmod
       (progn                                 ;Not Bypassed
        (setq edef (entget s)                 ;Get Old Definition
               old (assoc grpc edef)          ;Get Old Value
               new (cons grpc n)              ;Make New Set
              edef (subst new old edef))      ;Make New Definition
         (entmod edef)                        ;Modify Definition
          (entupd s)                          ;Update Entity
           (graphscr)                         ;Goto Graph Screen
            (repeat 18 (BkSp)))))))))))       ;Clear Command Line & End

(PDot);++++++++++++ Entity Information Routine +++++++++++++++++++++++++
 (defun en_ent ()                             ;Define en_ent
  (setq edef (entget s)                       ;Get Entity Values
       etype (GetVal 0 edef)                  ;Get Entity Type
       EList nil)                             ;Reset Group List
;------------ Test For Sequential Entities -----------------------------
(foreach x (list "ATTRIB" "POLYLINE" "VERTEX");If Type With Sequence
    (if (= etype x)(setq en_1 T)))            ;Follows Then Test 1 True
;------------ Test For Inserts With Attributes -------------------------
   (and (= etype "INSERT")                    ;If Insert
        (= (GetVal 66 edef) 1)                ;With Attributes
        (setq en_1 T))                        ;Then Test 1 True
;------------ Test For Sequence End ------------------------------------
    (if (= etype "SEQEND")                    ;If Seqend
        (setq en_1 nil en_4 T))               ;Exit Clean
;------------ Test For Viewports ---------------------------------------
    (if (= etype "VIEWPORT")(setq en_10 T))   ;If Viewport Test 10 True
;------------ Test For No Thickness Allowed ----------------------------
 (foreach x (list "3DFACE" "DIMENSION" "VERTEX" "ATTRIB" "VIEWPORT" "3DSOLID")
    (if (= etype x)(setq en_2 T)))            ;If No Thickness Test 2 T
;------------ Test For No Color Allowed --------------------------------
 (foreach x (list "ATTRIB" "VERTEX")
    (if (= etype x)(setq en_3 T)))            ;If No Color Test 3 True
;------------ Test For No Linetype Allowed -----------------------------
 (foreach x (list "INSERT" "3DFACE" "SOLID" "VERTEX" "VIEWPORT")
    (if (= etype x)(setq en_8 T)))            ;If No Linetype Test 8 T
;------------ Test For No Elevation Allowed ----------------------------
 (foreach x (list "3DFACE" "LINE" "SOLID" "DIMENSION" "VIEWPORT" "3DSOLID")
    (if (= etype x)(setq en_9 T)))            ;If No Elevation Test 9 T
;------------ Test For XREF Inserts ------------------------------------
  (if (= etype "INSERT")
      (setq en_12 (GetVal 1 (tblsearch "BLOCK" (GetVal 2 edef)))))
;------------ Test For 3DSOLIDS ----------------------------------------
  (if (= etype "3DSOLID")
      (setq en_13 T))
;------------ Print Group Code Description And Value -------------------
(textscr)                                     ;Goto Text Screen
 (repeat 25 (terpri))                         ;Clear Text Screen
 (setq sct 1)                                 ;Reset Screen Counter
  (if en_12 (princ "\nWarning! Cannot Access Attributes In An XREF\n"))
  (prompt " ")                                ;Align First Item
   (foreach v edef                            ;For Each Group
     (setq sct (1+ sct))                      ;Set Screen Counter
     (if (> sct 24)                           ;Limit To 24 Lines
         (en_more))                           ;On Text Screen
     (if (not (or (= (car v) 100)             ;Do Not Print Information
                  (and en_13 (= (car v) 1)))) ;On Release 13 Group 100
         (progn                               ;Print Values
    (setq EList (cons (car v) EList))         ;Add Code Int To List
    (if (member (car v) VList)                ;If Constant Name All
    (setq pcde (strcat (substr etype 1 3) (itoa (car v))))
    (setq pcde (strcat "ALL" (itoa (car v)))));Else Name 3 Letter Code
    (setq spc " "                             ;Set 1 Space
          des (GetVal pcde GList))            ;Get Description Value
 (if (not des)                                ;If Blank
  (prompt "\t\t\t- ")                         ;Print 3 Tabs
   (prompt (strcat (repeat (- 21 (strlen des));Else Get Spaces
    (setq spc (strcat spc " "))) des " - "))) ;Print Description
     (if (not (and en_13                      ;Check Release 13
                   (= (car v) 1)))            ;Sub Classes
         (princ v))                           ;Print The Value
      (print))))                              ;Issue A Return & Repeat
(if (= etype "LINE")                          ;For Lines
 (progn (prompt "\nLength = " )               ;List
  (princ (rtos (distance                      ;True
  (GetVal 10 edef)(GetVal 11 edef)) 2 8))     ;Length
  (prompt ", XY Angle = " )                   ;And
  (princ (angtos (angle                       ;XY Plane
  (GetVal 10 edef)(GetVal 11 edef)) 0 8))     ;Angle
  (print)))                                   ;Issue A Return
(if (= etype "CIRCLE")                        ;For Circles
 (progn (prompt "\nCircumference = " )        ;List
  (princ (rtos (* pi (* 2 (GetVal 40 edef)))));Circumference
  (prompt ", Area = " )                       ;And Area
  (princ (rtos (* pi (expt (GetVal 40 edef) 2))))
  (print))))                                  ;Issue A Return & End

(PDot);++++++++++++ More Output To Follow ++++++++++++++++++++++++++++++
 (defun en_more ()                            ;Define More
  (setq sct 1)                                ;Reset Counter
   (initget "Yes No")                         ;Ask To Continue
    (if (= "Yes"  (getkword "\n\nMore To Follow - Continue <N>:... "))
     (progn (textpage) (print))               ;If Yes Clear Text Screen
      (quit)))                                ;Else End Program

(PDot);++++++++++++ Next Sequential Entity Routine +++++++++++++++++++++
 (defun en_seq ()                             ;Define en_seq
  (setq en_5 nil)                             ;Reset Second Change
  (initget "Yes No")                          ;Ask To Continue
  (if (= "Yes"  (getkword "\nMore To Follow - Continue <N>:... "))
      (setq s (entnext s))                    ;If Yes Then Get Next
      (setq en_1 nil en_4 nil)))              ;Else End Program

(PDot);++++++++++++ Get Entity Name ++++++++++++++++++++++++++++++++++++
(defun en_get (/ st os)                       ;Define GetOne
 (setq os (getvar "SNAPMODE") s nil)          ;Set Old Snap & EName
 (setvar "SNAPMODE" 0)                        ;Turn Snaps Off
 (while (not st)                              ;Force Choice
        (setq st (ssget)))                    ;Allows L P C W
 (while (> (sslength st) 1)                   ;While More Than 1
        (prompt "\nOnly 1 At A Time Please\n");Inform User
        (setq st (ssget)))                    ;Try Again
 (setvar "SNAPMODE" os)                       ;Reset Snap Mode
 (setq s (ssname st 0))                       ;Return Selection Name
 (setq ms s)                                  ;Name Main Selection
 (textscr))                                   ;Goto Text Screen

(PDot);+++++++++++ Search Blocks For Nested Inserts ++++++++++++++++++++
 (defun en_sbk ()                             ;Define en_sbk
  (setq BList (list ""))                      ;Declare Empty List
  (initget "Yes No")                          ;Ask To Continue
  (if (= "Yes"  (getkword "\nSearch For Nested Blocks <N>:... "))
      (progn                                  ;If An Insert
  (setq bn (GetVal -2 (tblsearch "BLOCK" (GetVal 2 edef))))
  (setq el (entnext bn))                      ;Search Table
  (textpage)                                  ;Check
  (prompt                                     ;Each
   (strcat "Searching " (GetVal 2 edef) "  "));Reference
  (while el                                   ;For Inserts
   (PDot)                                     ;Display Status
   (setq mdef (entget el))                    ;Add Name To
   (if (= "INSERT" (GetVal 0 mdef))           ;List Of
       (progn                                 ;Blocks That
        (setq tdef (entget (GetVal -1 mdef))) ;Have Been Found
        (if (not (member (GetVal 2 tdef) BList));Bypass Duplicated
        (setq BList (cons (GetVal 2 tdef) BList)))));Names
   (setq el (entnext el)))                    ;Get Next Item
  (if (= (car BList) "")                      ;If Empty List
      (princ "\n\n\t- None Found -")          ;Inform User
      (progn                                  ;Else
        (prompt "\nNested Blocks Found\n")    ;Print Names
        (foreach x BList                      ;Of Nested
          (prompt (strcat "\n\t" x))))))))    ;Blocks Found

(PDot);++++++++++++ Print Color Tables +++++++++++++++++++++++++++++++++
 (defun en_pc ()                              ;Print Each Atom
 (foreach c CList                             ;Of Color Table
   (prompt (strcat "\n\t" (itoa (car c)) " " (cdr c)))))

(PDot);************ Display Only Program *******************************
 (defun Info (/ en_4 pcde spc EList ms en_1 en_12
                edef etype des olderr s bn el mdef tdef en_13
                m_n m_v m_s m_l sct)
  (setq en_4 T)                               ;Force Text Screen
; (setq *error* nil)                          ;Debugging Aid
   (en_smd)                                   ;Set Modes
    (en_get)                                  ;Get Entity
     (en_ent)                                 ;Display Main Entity
           (if (and                           ;For Types That Are
               (/= etype "3DFACE")            ;Not 3DFaces
               (/= etype "VIEWPORT")          ;Viewports
               (/= etype "3DSOLID"))          ;3DSolids
               (en_ucs))                      ;Check UCS
      (if (= etype "INSERT")(en_sbk))         ;Search For Blocks
       (if en_1 (en_seq))                     ;Display
    (while en_1 (en_ent)                      ;Sequences
     (if en_1 (en_seq)))                      ;And
      (en_rmd))                               ;Restore Modes

(PDot);************ Main Program ***************************************
 (defun Enfo (/ new old pcde etype olderr pmt old new ms gp en_13
                s n des spc val grpc edef PList RList EList en_12
                en_1 en_2 en_3 en_4 en_5 en_6 en_7 en_8 en_9 en_10 en_11
                xpt ypt ex celv ielv nlev olderr m_n m_v m_s m_l sct edir)
  (en_smd)                             ;Set Modes
;  (setq *error* nil)                  ;Debugging Aid
   (en_get)                            ;Call Get Entity
    (en_ent)                           ;Call Information Routine
     (en_ch1)                          ;Call First Change Routine
      (while en_5 (en_ch2))            ;For Subsequent Change Routines
       (if en_1 (en_seq))              ;Call Sequential Routine
   (while en_1                         ;While A Sequenced
    (progn                             ;Entity Exists
     (en_ent)                          ;Call Information Routine
      (en_ch1)                         ;Call First Change Routine
       (while en_5 (en_ch2))           ;For Subsequent Change Routines
        (if en_1 (en_seq))))           ;If A Sequence Exists Call Seq
         (en_rmd))                     ;Return Modes & End

(PDot);@@@@@@@@@@@@ Load Programs @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 (defun C:ENFO () (Enfo))                     ;Make Commands
 (defun C:INFO () (Info))                     ;Resident
 (if ENFO (princ "\nENfo & INfo Defined\n"))  ;Confirm Loading
 (prin1)                                      ;Else Display Errors
; End Program 
;"AS IS" Public Domain Software Donated By
;
;      
;                                    ͻ
;               ۳                                            
;                             Fabricated Designs, Inc.  
;            >    <                                         
;                              ͼ
;      
;
;
;
;        Fabricated Designs, Inc.
;        32 Maury Avenue
;        Newport News, Virginia  23601-2132
;         Ph: (804) 595-5949
;        FAX: (804) 595-5787
;        CIS: 73544,2655
;   Internet: http://ourworld.compuserve.com/homepages/D_Bethel/
;
